Name:		gprolog
Version:	1.5.0
Release:    2%{?dist}
Summary:	GNU Prolog is a free Prolog compiler

License:	LGPL-3.0-or-later OR GPL-2.0-or-later
URL:		http://www.gprolog.org
Source0:		http://www.gprolog.org/gprolog-%{version}.tar.gz
Patch0:		gprolog.make-print-submake-output.patch
Patch1:		gprolog.link-flags.patch

BuildRequires:	gcc-c++
BuildRequires:	gdb-headless
BuildRequires:	make

ExclusiveArch:	x86_64 %{ix86} ppc alpha aarch64

Provides:	gprolog-examples = %{version}-%{release}

%description 
GNU Prolog is a native Prolog compiler with constraint solving over
finite domains (FD) developed by Daniel Diaz
(http://loco.inria.fr/~diaz).

GNU Prolog is a very efficient native compiler producing (small)
stand-alone executables. GNU-Prolog also offers a classical
top-level+debugger.

GNU Prolog conforms to the ISO standard for Prolog but also includes a
lot of extensions (global variables, DCG, sockets, OS interface,...).

GNU Prolog also includes a powerful constraint solver over finite
domains with many predefined constraints+heuristics.


%package docs
Summary:	Documentation for GNU Prolog
Requires:	%{name} = %{version}-%{release}

%description docs
Documentation for GNU Prolog.

%prep
%autosetup -p1

verdate=$(date +"%b %d %Y" -r VERSION)
veryear=$(date +%Y -r VERSION)
sed -i s/'`pl_date`'/"\"$verdate\""/';'s/'`pl_year`'/"$veryear"/ src/configure

%build
%define _lto_cflags %{nil}

cd src

%define _legacy_common_support 1

%configure \
      --with-install-dir=%{buildroot}%{_libdir}/gprolog-%{version} \
      --without-links-dir --without-examples-dir \
      --with-doc-dir=dist-doc \
      --with-c-flags="$RPM_OPT_FLAGS" \
%ifarch %{ix86}
      --disable-regs
%endif

sed -i 's/ -Wl,-dT.*\.ld//' EnginePl/gp_config.h

make

%check
cd src
export PATH=%{buildroot}%{_bindir}:$PATH
make check

%install
cd src
(
    make install
    mkdir %{buildroot}%{_bindir}
    cd %{buildroot}%{_libdir}/gprolog-%{version}/bin
    for i in *; do
	ln -s ../%{_lib}/gprolog-%{version}/bin/$i %{buildroot}%{_bindir}/$i
    done
)
rm -f dist-doc/*.{chm,dvi,ps}
rm -f dist-doc/compil-scheme.pdf
rm -f dist-doc/debug-box.pdf

for file in ChangeLog COPYING NEWS README VERSION
do
    rm -f %{buildroot}%{_libdir}/gprolog-%{version}/$file
done

%files
%doc README COPYING ChangeLog NEWS PROBLEMS VERSION
%{_bindir}/*
%{_libdir}/gprolog-%{version}

%files docs
%doc src/dist-doc/*

%changelog
* Tue May 07 2024 Fanjun Kong <fanjunkong@tencent.com> - 1.5.0-2
- epol debrand

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.0-1
- initial build
